Unit AMZ3C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AMZ3C(var A :Array of Complex; N :Integer; NUC :Integer;
                NLC :Integer; var B :Array of Complex);

implementation

procedure AMZ3C(var A :Array of Complex; N :Integer; NUC :Integer;
                NLC :Integer; var B :Array of Complex);
var
NMNUC,JJ,NLCP1,NEPT,I,J,K,L,KK,LPNEPT :Integer;
const
ZERO :Complex = ( re:0.0E0; im: 0.0E0 );
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10;
begin
NMNUC := N-NUC;
JJ := NLC;
NLCP1 := NLC+1;
NEPT := NMNUC;
L := NUC+1;
for I:=1 to NLCP1 do
 begin
  for J:=1 to L do
   begin
    K := JJ+J;
    B[(I-1)+(J-1)*N] := A[(I-1)+(K-1)*N];
_1:
   end;
  if ( I < NEPT ) 
   then L := L+1;
  JJ := JJ-1;
_2:
 end;
if ( NLCP1 = N ) 
 then goto _7;
NLCP1 := NLCP1+1;
L := 2;
NEPT := Min0(NLC+2+NUC,N);
K := NEPT-1;
for I:=NLCP1 to N do
 begin
  KK := K;
  LPNEPT := L+NEPT;
  for J:=L to NEPT do
   begin
    JJ := LPNEPT-J;
    B[(I-1)+(JJ-1)*N] := A[(I-1)+(KK-1)*N];
    KK := KK-1;
_3:
   end;
  if ( I >= NMNUC ) 
   then K := K-1;
  L := L+1;
  NEPT := Min0(NEPT+1,N);
_4:
 end;
K := 1;
for I:=NLCP1 to N do
 begin
  for J:=1 to K do
   begin
    B[(I-1)+(J-1)*N] := ZERO;
_5:
   end;
  K := K+1;
_6:
 end;
_7:
L := NUC+1;
if ( L = N ) 
 then goto _10;
K := N-L;
L := L+1;
for I:=1 to K do
 begin
  for J:=L to N do
   begin
    B[(I-1)+(J-1)*N] := ZERO;
_8:
   end;
  L := L+1;
_9:
 end;
_10:
end;

end.
